// sample2d.cpp
// by Glenn G. Chappell
// September 2003
//
// For CS 381
// Sample 2-D OpenGL/GLUT program

#include <iostream>
using std::cout;
using std::cerr;
using std::endl;
#include <GL/glut.h> // GLUT stuff, includes OpenGL headers as well


// Global variables
// Window/viewport
const int startwinsize = 400; // Starting window width & height, in pixels


// display
// The GLUT display function
void display()
{
   glClear(GL_COLOR_BUFFER_BIT);

   glColor3d(0.1, 0.1, 0.8);
   glBegin(GL_LINE_LOOP);
      glVertex2d(0.05, 0.05);
      glVertex2d(0.95, 0.05);
      glVertex2d(0.95, 0.95);
      glVertex2d(0.05, 0.95);
   glEnd();

   glColor3d(0.9, 0.1, 0.1);
   glBegin(GL_LINES);
      glVertex2d(0.85, 0.4);
      glVertex2d(0.85, 0.6);
      glVertex2d(0.65, 0.6);
      glVertex2d(0.65, 0.4);
   glEnd();

   glColor3d(0.7, 0.1, 0.9);
   glBegin(GL_QUADS);
      glVertex2d(0.15, 0.4);
      glVertex2d(0.15, 0.6);
      glVertex2d(0.35, 0.6);
      glVertex2d(0.35, 0.4);
   glEnd();

   glColor3d(0.9, 0.9, 0.1);
   glBegin(GL_POLYGON);
      glVertex2d(0.5, 0.65);
      glVertex2d(0.4, 0.85);
      glVertex2d(0.6, 0.85);
   glEnd();

   glColor3d(0.0, 0.0, 0.0);
   glBegin(GL_LINE_STRIP);
      glVertex2d(0.5, 0.35);
      glVertex2d(0.4, 0.15);
      glVertex2d(0.6, 0.15);
   glEnd();

   glFlush();
}


// idle
// The GLUT idle function
void idle()
{
   // Print OpenGL errors, if there are any (for debugging)
   if (GLenum err = glGetError())
   {
      cerr << "OpenGL ERROR: " << gluErrorString(err) << endl;
   }
}


// init
// Initializes GL states
// Called by main after window creation
void init()
{
   glClearColor(0.5, 0.9, 0.5, 0.0);

   glLineWidth(5.0);

   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(0.0, 1.0, 0.0, 1.0);

   glMatrixMode(GL_MODELVIEW);  // Always go back to model/view mode

   // Documentation
   cout << "Sample 2-D OpenGL/GLUT Program" << endl;
   cout << "by Glenn G. Chappell" << endl;
   cout << "for CS 381, Fall 2003" << endl;
   cout << endl;
   cout << "Kill window to quit." << endl;
}


int main(int argc, char ** argv)
{
   // Initialize OpenGL/GLUT
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);

   // Make a window
   glutInitWindowSize(startwinsize, startwinsize);
   glutInitWindowPosition(50, 50);
   glutCreateWindow("CS 381 - Sample 2-D Program");

   // Initialize GL states & register callbacks
   init();
   glutDisplayFunc(display); 
   glutIdleFunc(idle);

   // Do something
   glutMainLoop();

   return 0;
}
